/* Generated by re2c 0.10.3 on Wed Sep 13 11:36:51 2006 */
#line 1 "tokenizer.re"
/* 
 * Copyright (C) 2006 Cooper Street Innovations Inc.
 *	Charles Eidsness    <charles@cooper-street.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
 * 02110-1301, USA.
 *
 */

#include "log.h"
#include "tokenizer.h"
#include "parser.h"

/* RE Format parser defines */
#define	YYCTYPE		char
#define	YYCURSOR	cursor
#define	YYMARKER	marker

#line 33 "tokenizer.re"


#line 45 "tokenizer.re"


static token_ * newToken(int type, double **variable, double constant,
		double *minDiv)
{
	token_ *r;
	r = malloc(sizeof(token_));
	ReturnNULLIf(r == NULL, "Malloc Failed");
	r->type = type;
	r->variable = variable;
	r->constant = constant;
	r->minDiv = minDiv;
	r->next = NULL;
	return r;
}

int tokenizerDestroyAll(token_ **r)
{
	token_ *ptr, *ptrNext;
	
	ReturnErrIf(r == NULL, "Bad Pointer");
	ReturnErrIf((*r) == NULL, "Not initialised");
	Debug("Destroying Tokenizer %p", (*r));
	
	for(ptr = (*r); ptr != NULL; ptr = ptrNext) {
		ptrNext = ptr->next;
		free(ptr);
	}
	
	*r = NULL;
	return 0;
}

#define Attach(tok, var, con, minDiv) \
	tail->next = newToken(tok, var, con, minDiv); \
	GotoFailedIf(tail->next == NULL); \
	tail = tail->next

token_ * tokenizerNew(token_ *r, char *buffer, tokenizerGetVarPtr getVarFunc, 
		void *private, double *minDiv)
{
	token_ *head = NULL, *tail = NULL;
	char *cursor = NULL, *marker = NULL, *start = NULL, tmp0, iv = 'v';
	double **variable;
	
	ReturnNULLIf(r != NULL);
	ReturnNULLIf(buffer == NULL);
	ReturnNULLIf(getVarFunc == NULL);
	
	Debug("Creating tokenizer");
	cursor = buffer;
	marker = buffer;
	head = newToken(-1, NULL, 0, NULL);
	ReturnNULLIf(head == NULL);
	tail = head;
	
parse:
	start = cursor;
{
	static unsigned char yybm[] = {
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0, 128,  64,   0,   0,  64,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		128,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,   0,   0,   0,   0,   0,   0, 
		  0,  16,  16,  16,  16,  16,  16,  16, 
		 16,  16,  16,  16,  16,  16,  16,  16, 
		 16,  16,  16,  16,  16,  16,  16,  16, 
		 16,  16,  16,   0,   0,   0,   0,   0, 
		  0,  16,  16,  16,  16,  16,  16,  16, 
		 16,  16,  16,  16,  16,  16,  16,  16, 
		 16,  16,  16,  16,  16,  16,  16,  16, 
		 16,  16,  16,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
	};

#line 132 "tokenizer.c"
	{
		YYCTYPE yych;
		unsigned int yyaccept = 0;

		yych = *YYCURSOR;
		switch(yych){
		case 0x00:	goto yy6;
		case 0x09:
		case ' ':	goto yy2;
		case 0x0A:
		case 0x0D:	goto yy4;
		case '(':	goto yy28;
		case ')':	goto yy30;
		case '*':	goto yy22;
		case '+':	goto yy18;
		case '-':	goto yy20;
		case '.':	goto yy34;
		case '/':	goto yy24;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':	goto yy32;
		case 'A':
		case 'a':	goto yy11;
		case 'B':
		case 'D':
		case 'F':
		case 'G':
		case 'H':
		case 'J':
		case 'K':
		case 'M':
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'R':
		case 'W':
		case 'X':
		case 'Y':
		case 'Z':
		case 'b':
		case 'd':
		case 'f':
		case 'g':
		case 'h':
		case 'j':
		case 'k':
		case 'm':
		case 'n':
		case 'o':
		case 'p':
		case 'q':
		case 'r':
		case 'w':
		case 'x':
		case 'y':
		case 'z':	goto yy35;
		case 'C':
		case 'c':	goto yy12;
		case 'E':
		case 'e':	goto yy13;
		case 'I':
		case 'i':	goto yy10;
		case 'L':
		case 'l':	goto yy14;
		case 'S':
		case 's':	goto yy15;
		case 'T':
		case 't':	goto yy16;
		case 'U':
		case 'u':	goto yy17;
		case 'V':
		case 'v':	goto yy8;
		case '^':	goto yy26;
		default:	goto yy36;
		}
yy2:
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy129;
yy3:
#line 104 "tokenizer.re"
		{ goto parse; }
#line 223 "tokenizer.c"
yy4:
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if(yybm[0+yych] & 64) {
			goto yy126;
		}
		if(yych == '+') goto yy125;
yy5:
#line 143 "tokenizer.re"
		{ Error("Unexpected character %s", cursor-1);	goto failed; }
#line 234 "tokenizer.c"
yy6:
		++YYCURSOR;
#line 105 "tokenizer.re"
		{ Attach(0, NULL, 0, NULL);						goto passed; }
#line 239 "tokenizer.c"
yy8:
		++YYCURSOR;
		if((yych = *YYCURSOR) == '(') goto yy123;
		goto yy38;
yy9:
#line 134 "tokenizer.re"
		{ 
		tmp0 = *cursor;
		*cursor = 0x0;
		variable = getVarFunc(start, 0x0, private);
		GotoFailedIf(variable == NULL, "User rejected the variable %s", start);
		Attach(TOKEN_VARIABLE, variable, 0, NULL);
		*cursor = tmp0;
		goto parse;
	}
#line 255 "tokenizer.c"
yy10:
		yych = *++YYCURSOR;
		if(yych == '(') goto yy121;
		goto yy38;
yy11:
		yych = *++YYCURSOR;
		if(yych <= 'T') {
			if(yych <= 'C') {
				if(yych <= 'A') goto yy38;
				if(yych <= 'B') goto yy93;
				goto yy94;
			} else {
				if(yych <= 'R') goto yy38;
				if(yych <= 'S') goto yy95;
				goto yy96;
			}
		} else {
			if(yych <= 'c') {
				if(yych <= 'a') goto yy38;
				if(yych <= 'b') goto yy93;
				goto yy94;
			} else {
				if(yych <= 'r') goto yy38;
				if(yych <= 's') goto yy95;
				if(yych <= 't') goto yy96;
				goto yy38;
			}
		}
yy12:
		yych = *++YYCURSOR;
		if(yych == 'O') goto yy86;
		if(yych == 'o') goto yy86;
		goto yy38;
yy13:
		yych = *++YYCURSOR;
		if(yych == 'X') goto yy82;
		if(yych == 'x') goto yy82;
		goto yy38;
yy14:
		yych = *++YYCURSOR;
		if(yych <= 'O') {
			if(yych <= 'M') goto yy38;
			if(yych <= 'N') goto yy75;
			goto yy76;
		} else {
			if(yych <= 'm') goto yy38;
			if(yych <= 'n') goto yy75;
			if(yych <= 'o') goto yy76;
			goto yy38;
		}
yy15:
		yych = *++YYCURSOR;
		if(yych <= 'Q') {
			if(yych == 'I') goto yy63;
			if(yych <= 'P') goto yy38;
			goto yy64;
		} else {
			if(yych <= 'i') {
				if(yych <= 'h') goto yy38;
				goto yy63;
			} else {
				if(yych == 'q') goto yy64;
				goto yy38;
			}
		}
yy16:
		yych = *++YYCURSOR;
		if(yych == 'A') goto yy59;
		if(yych == 'a') goto yy59;
		goto yy38;
yy17:
		yych = *++YYCURSOR;
		if(yych <= 'Q') {
			if(yych == '(') goto yy52;
			goto yy38;
		} else {
			if(yych <= 'R') goto yy51;
			if(yych == 'r') goto yy51;
			goto yy38;
		}
yy18:
		++YYCURSOR;
#line 126 "tokenizer.re"
		{ Attach(TOKEN_PLUS, NULL, 0, minDiv);		goto parse; }
#line 340 "tokenizer.c"
yy20:
		++YYCURSOR;
#line 127 "tokenizer.re"
		{ Attach(TOKEN_MINUS, NULL, 0, minDiv);	goto parse; }
#line 345 "tokenizer.c"
yy22:
		++YYCURSOR;
#line 128 "tokenizer.re"
		{ Attach(TOKEN_TIMES, NULL, 0, minDiv);	goto parse; }
#line 350 "tokenizer.c"
yy24:
		++YYCURSOR;
#line 129 "tokenizer.re"
		{ Attach(TOKEN_DIVIDE, NULL, 0, minDiv);	goto parse; }
#line 355 "tokenizer.c"
yy26:
		++YYCURSOR;
#line 130 "tokenizer.re"
		{ Attach(TOKEN_POWER, NULL, 0, minDiv);	goto parse; }
#line 360 "tokenizer.c"
yy28:
		++YYCURSOR;
#line 131 "tokenizer.re"
		{ Attach(TOKEN_LPAREN, NULL, 0, NULL);		goto parse; }
#line 365 "tokenizer.c"
yy30:
		++YYCURSOR;
#line 132 "tokenizer.re"
		{ Attach(TOKEN_RPAREN, NULL, 0, NULL);		goto parse; }
#line 370 "tokenizer.c"
yy32:
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		goto yy48;
yy33:
#line 133 "tokenizer.re"
		{ Attach(TOKEN_CONSTANT, NULL, atof(start), NULL); goto parse; }
#line 378 "tokenizer.c"
yy34:
		yych = *++YYCURSOR;
		if(yybm[0+yych] & 32) {
			goto yy39;
		}
		goto yy5;
yy35:
		yych = *++YYCURSOR;
		goto yy38;
yy36:
		yych = *++YYCURSOR;
		goto yy5;
yy37:
		++YYCURSOR;
		yych = *YYCURSOR;
yy38:
		if(yybm[0+yych] & 16) {
			goto yy37;
		}
		goto yy9;
yy39:
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		yych = *YYCURSOR;
		if(yybm[0+yych] & 32) {
			goto yy39;
		}
		if(yych == 'E') goto yy41;
		if(yych != 'e') goto yy33;
yy41:
		yych = *++YYCURSOR;
		if(yych <= ',') {
			if(yych == '+') goto yy43;
		} else {
			if(yych <= '-') goto yy43;
			if(yych <= '/') goto yy42;
			if(yych <= '9') goto yy44;
		}
yy42:
		YYCURSOR = YYMARKER;
		if(yyaccept <= 0) {
			goto yy5;
		} else {
			goto yy33;
		}
yy43:
		yych = *++YYCURSOR;
		if(yych <= '/') goto yy42;
		if(yych >= ':') goto yy42;
yy44:
		++YYCURSOR;
		yych = *YYCURSOR;
		if(yych <= '/') goto yy33;
		if(yych <= '9') goto yy44;
		goto yy33;
yy46:
		yych = *++YYCURSOR;
		if(yych <= '/') goto yy42;
		if(yych <= '9') goto yy49;
		goto yy42;
yy47:
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		yych = *YYCURSOR;
yy48:
		if(yych <= '9') {
			if(yych == '.') goto yy46;
			if(yych <= '/') goto yy33;
			goto yy47;
		} else {
			if(yych <= 'E') {
				if(yych <= 'D') goto yy33;
				goto yy41;
			} else {
				if(yych == 'e') goto yy41;
				goto yy33;
			}
		}
yy49:
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		yych = *YYCURSOR;
		if(yych <= 'D') {
			if(yych <= '/') goto yy33;
			if(yych <= '9') goto yy49;
			goto yy33;
		} else {
			if(yych <= 'E') goto yy41;
			if(yych == 'e') goto yy41;
			goto yy33;
		}
yy51:
		yych = *++YYCURSOR;
		if(yych == 'A') goto yy54;
		if(yych == 'a') goto yy54;
		goto yy38;
yy52:
		++YYCURSOR;
#line 125 "tokenizer.re"
		{ Attach(TOKEN_U, NULL, 0, minDiv);		goto parse; }
#line 479 "tokenizer.c"
yy54:
		yych = *++YYCURSOR;
		if(yych == 'M') goto yy55;
		if(yych != 'm') goto yy38;
yy55:
		yych = *++YYCURSOR;
		if(yych == 'P') goto yy56;
		if(yych != 'p') goto yy38;
yy56:
		yych = *++YYCURSOR;
		if(yych != '(') goto yy38;
		++YYCURSOR;
#line 124 "tokenizer.re"
		{ Attach(TOKEN_URAMP, NULL, 0, minDiv);	goto parse; }
#line 494 "tokenizer.c"
yy59:
		yych = *++YYCURSOR;
		if(yych == 'N') goto yy60;
		if(yych != 'n') goto yy38;
yy60:
		yych = *++YYCURSOR;
		if(yych != '(') goto yy38;
		++YYCURSOR;
#line 123 "tokenizer.re"
		{ Attach(TOKEN_TAN, NULL, 0, minDiv);		goto parse; }
#line 505 "tokenizer.c"
yy63:
		yych = *++YYCURSOR;
		if(yych == 'N') goto yy69;
		if(yych == 'n') goto yy69;
		goto yy38;
yy64:
		yych = *++YYCURSOR;
		if(yych == 'R') goto yy65;
		if(yych != 'r') goto yy38;
yy65:
		yych = *++YYCURSOR;
		if(yych == 'T') goto yy66;
		if(yych != 't') goto yy38;
yy66:
		yych = *++YYCURSOR;
		if(yych != '(') goto yy38;
		++YYCURSOR;
#line 122 "tokenizer.re"
		{ Attach(TOKEN_SQRT, NULL, 0, minDiv);		goto parse; }
#line 525 "tokenizer.c"
yy69:
		yych = *++YYCURSOR;
		if(yych <= 'G') {
			if(yych == '(') goto yy71;
			goto yy38;
		} else {
			if(yych <= 'H') goto yy70;
			if(yych != 'h') goto yy38;
		}
yy70:
		yych = *++YYCURSOR;
		if(yych == '(') goto yy73;
		goto yy38;
yy71:
		++YYCURSOR;
#line 121 "tokenizer.re"
		{ Attach(TOKEN_SIN, NULL, 0, minDiv);		goto parse; }
#line 543 "tokenizer.c"
yy73:
		++YYCURSOR;
#line 120 "tokenizer.re"
		{ Attach(TOKEN_SINH, NULL, 0, minDiv);		goto parse; }
#line 548 "tokenizer.c"
yy75:
		yych = *++YYCURSOR;
		if(yych == '(') goto yy80;
		goto yy38;
yy76:
		yych = *++YYCURSOR;
		if(yych == 'G') goto yy77;
		if(yych != 'g') goto yy38;
yy77:
		yych = *++YYCURSOR;
		if(yych != '(') goto yy38;
		++YYCURSOR;
#line 119 "tokenizer.re"
		{ Attach(TOKEN_LOG, NULL, 0, minDiv);		goto parse; }
#line 563 "tokenizer.c"
yy80:
		++YYCURSOR;
#line 118 "tokenizer.re"
		{ Attach(TOKEN_LN, NULL, 0, minDiv);		goto parse; }
#line 568 "tokenizer.c"
yy82:
		yych = *++YYCURSOR;
		if(yych == 'P') goto yy83;
		if(yych != 'p') goto yy38;
yy83:
		yych = *++YYCURSOR;
		if(yych != '(') goto yy38;
		++YYCURSOR;
#line 117 "tokenizer.re"
		{ Attach(TOKEN_EXP, NULL, 0, minDiv);		goto parse; }
#line 579 "tokenizer.c"
yy86:
		yych = *++YYCURSOR;
		if(yych == 'S') goto yy87;
		if(yych != 's') goto yy38;
yy87:
		yych = *++YYCURSOR;
		if(yych <= 'G') {
			if(yych == '(') goto yy89;
			goto yy38;
		} else {
			if(yych <= 'H') goto yy88;
			if(yych != 'h') goto yy38;
		}
yy88:
		yych = *++YYCURSOR;
		if(yych == '(') goto yy91;
		goto yy38;
yy89:
		++YYCURSOR;
#line 116 "tokenizer.re"
		{ Attach(TOKEN_COS, NULL, 0, minDiv);		goto parse; }
#line 601 "tokenizer.c"
yy91:
		++YYCURSOR;
#line 115 "tokenizer.re"
		{ Attach(TOKEN_COSH, NULL, 0, minDiv);		goto parse; }
#line 606 "tokenizer.c"
yy93:
		yych = *++YYCURSOR;
		if(yych == 'S') goto yy118;
		if(yych == 's') goto yy118;
		goto yy38;
yy94:
		yych = *++YYCURSOR;
		if(yych == 'O') goto yy111;
		if(yych == 'o') goto yy111;
		goto yy38;
yy95:
		yych = *++YYCURSOR;
		if(yych == 'I') goto yy104;
		if(yych == 'i') goto yy104;
		goto yy38;
yy96:
		yych = *++YYCURSOR;
		if(yych == 'A') goto yy97;
		if(yych != 'a') goto yy38;
yy97:
		yych = *++YYCURSOR;
		if(yych == 'N') goto yy98;
		if(yych != 'n') goto yy38;
yy98:
		yych = *++YYCURSOR;
		if(yych <= 'G') {
			if(yych == '(') goto yy100;
			goto yy38;
		} else {
			if(yych <= 'H') goto yy99;
			if(yych != 'h') goto yy38;
		}
yy99:
		yych = *++YYCURSOR;
		if(yych == '(') goto yy102;
		goto yy38;
yy100:
		++YYCURSOR;
#line 114 "tokenizer.re"
		{ Attach(TOKEN_ATAN, NULL, 0, minDiv);		goto parse; }
#line 647 "tokenizer.c"
yy102:
		++YYCURSOR;
#line 113 "tokenizer.re"
		{ Attach(TOKEN_ATANH, NULL, 0, minDiv);	goto parse; }
#line 652 "tokenizer.c"
yy104:
		yych = *++YYCURSOR;
		if(yych == 'N') goto yy105;
		if(yych != 'n') goto yy38;
yy105:
		yych = *++YYCURSOR;
		if(yych <= 'G') {
			if(yych == '(') goto yy107;
			goto yy38;
		} else {
			if(yych <= 'H') goto yy106;
			if(yych != 'h') goto yy38;
		}
yy106:
		yych = *++YYCURSOR;
		if(yych == '(') goto yy109;
		goto yy38;
yy107:
		++YYCURSOR;
#line 112 "tokenizer.re"
		{ Attach(TOKEN_ASIN, NULL, 0, minDiv);		goto parse; }
#line 674 "tokenizer.c"
yy109:
		++YYCURSOR;
#line 111 "tokenizer.re"
		{ Attach(TOKEN_ASINH, NULL, 0, minDiv);	goto parse; }
#line 679 "tokenizer.c"
yy111:
		yych = *++YYCURSOR;
		if(yych == 'S') goto yy112;
		if(yych != 's') goto yy38;
yy112:
		yych = *++YYCURSOR;
		if(yych <= 'G') {
			if(yych == '(') goto yy114;
			goto yy38;
		} else {
			if(yych <= 'H') goto yy113;
			if(yych != 'h') goto yy38;
		}
yy113:
		yych = *++YYCURSOR;
		if(yych == '(') goto yy116;
		goto yy38;
yy114:
		++YYCURSOR;
#line 110 "tokenizer.re"
		{ Attach(TOKEN_ACOS, NULL, 0, minDiv);		goto parse; }
#line 701 "tokenizer.c"
yy116:
		++YYCURSOR;
#line 109 "tokenizer.re"
		{ Attach(TOKEN_ACOSH, NULL, 0, minDiv);	goto parse; }
#line 706 "tokenizer.c"
yy118:
		yych = *++YYCURSOR;
		if(yych != '(') goto yy38;
		++YYCURSOR;
#line 108 "tokenizer.re"
		{ Attach(TOKEN_ABS, NULL, 0, minDiv);		goto parse; }
#line 713 "tokenizer.c"
yy121:
		++YYCURSOR;
#line 107 "tokenizer.re"
		{ Attach(TOKEN_LPAREN, NULL, 0, NULL); iv='i';	goto parse_iv; }
#line 718 "tokenizer.c"
yy123:
		++YYCURSOR;
#line 106 "tokenizer.re"
		{ Attach(TOKEN_LPAREN, NULL, 0, NULL); iv='v';	goto parse_iv; }
#line 723 "tokenizer.c"
yy125:
		yych = *++YYCURSOR;
		goto yy3;
yy126:
		++YYCURSOR;
		yych = *YYCURSOR;
		if(yybm[0+yych] & 64) {
			goto yy126;
		}
		if(yych == '+') goto yy125;
		goto yy42;
yy128:
		++YYCURSOR;
		yych = *YYCURSOR;
yy129:
		if(yybm[0+yych] & 128) {
			goto yy128;
		}
		goto yy3;
	}
}
#line 144 "tokenizer.re"


parse_iv:
	start = cursor;
{
	static unsigned char yybm[] = {
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0, 128,  64,   0,   0,  64,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		128,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,   0,   0,   0,   0,   0,   0, 
		  0,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,   0,   0,   0,   0,   0, 
		  0,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
	};

#line 786 "tokenizer.c"
	{
		YYCTYPE yych;
		yych = *YYCURSOR;
		if(yych <= ')') {
			if(yych <= 0x0C) {
				if(yych <= 0x08) goto yy142;
				if(yych <= 0x09) goto yy132;
				if(yych <= 0x0A) goto yy134;
				goto yy142;
			} else {
				if(yych <= 0x1F) {
					if(yych <= 0x0D) goto yy134;
					goto yy142;
				} else {
					if(yych <= ' ') goto yy132;
					if(yych <= '(') goto yy142;
					goto yy136;
				}
			}
		} else {
			if(yych <= '9') {
				if(yych == ',') goto yy138;
				if(yych <= '/') goto yy142;
				goto yy140;
			} else {
				if(yych <= 'Z') {
					if(yych <= '@') goto yy142;
					goto yy140;
				} else {
					if(yych <= '`') goto yy142;
					if(yych <= 'z') goto yy140;
					goto yy142;
				}
			}
		}
yy132:
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy150;
yy133:
#line 149 "tokenizer.re"
		{ goto parse_iv; }
#line 829 "tokenizer.c"
yy134:
		yych = *(YYMARKER = ++YYCURSOR);
		if(yybm[0+yych] & 64) {
			goto yy146;
		}
		if(yych == '+') goto yy145;
yy135:
#line 161 "tokenizer.re"
		{ cursor--; Error("Unexpected character %s", cursor);	goto failed; }
#line 839 "tokenizer.c"
yy136:
		++YYCURSOR;
#line 150 "tokenizer.re"
		{ Attach(TOKEN_RPAREN, NULL, 0, NULL);		goto parse; }
#line 844 "tokenizer.c"
yy138:
		++YYCURSOR;
#line 151 "tokenizer.re"
		{ Attach(TOKEN_MINUS, NULL, 0, NULL);		goto parse_iv; }
#line 849 "tokenizer.c"
yy140:
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy144;
yy141:
#line 152 "tokenizer.re"
		{ 
		tmp0 = *cursor;
		*cursor = 0x0;
		variable = getVarFunc(start, iv, private);
		GotoFailedIf(variable == NULL, "User rejected the variable %s", start);
		Attach(TOKEN_VARIABLE, variable, 0, NULL);
		*cursor = tmp0;
		goto parse_iv;
	}
#line 865 "tokenizer.c"
yy142:
		yych = *++YYCURSOR;
		goto yy135;
yy143:
		++YYCURSOR;
		yych = *YYCURSOR;
yy144:
		if(yybm[0+yych] & 32) {
			goto yy143;
		}
		goto yy141;
yy145:
		yych = *++YYCURSOR;
		goto yy133;
yy146:
		++YYCURSOR;
		yych = *YYCURSOR;
		if(yybm[0+yych] & 64) {
			goto yy146;
		}
		if(yych == '+') goto yy145;
		YYCURSOR = YYMARKER;
		goto yy135;
yy149:
		++YYCURSOR;
		yych = *YYCURSOR;
yy150:
		if(yybm[0+yych] & 128) {
			goto yy149;
		}
		goto yy133;
	}
}
#line 162 "tokenizer.re"


passed:
	tail = head->next;
	free(head);
	return tail;
failed:
	tokenizerDestroyAll(&head);
	return NULL;
}
