/* 
 * Copyright (C) 2006 Cooper Street Innovations Inc.
 *	Charles Eidsness    <charles@cooper-street.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
 * 02110-1301, USA.
 *
 */
        
#ifndef COMMAND_H
#define COMMAND_H

#include "state.h"
#include "matrix.h"
#include "device.h"

typedef struct _command command_;

int commandConfigOpPoint(command_ *r);
int commandConfigTransient(command_ *r, double tstep, double tstop, 
		double tstart, double tmax, int uic);

int commandDestroy(command_ **r);
command_ * commandNew(command_ *r, matrix_ *matrix, deviceDB_ *devices);

typedef struct _commandDB commandDB_;

int commandDBExecute(commandDB_ *r, state_ *state);

int commandDBAttach(commandDB_ *r, command_ *command);
int commandDBDestroy(commandDB_ **r);
commandDB_ * commandDBNew(commandDB_ *r);

#endif
