/* 
 * Copyright (C) 2006 Cooper Street Innovations Inc.
 *	Charles Eidsness    <charles@cooper-street.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
 * 02110-1301, USA.
 *
 */

#ifndef COMMAND_INTERNAL_H
#define COMMAND_INTERNAL_H

#include "state_commands.h"
#include "matrix.h"
#include "device.h"

typedef struct _command command_;

typedef int (*commandFunction_)(command_ *r);
typedef int (*commandExeFunction_)(command_ *r, state_ *state);
typedef struct _commandPrivate commandPrivate_;
struct _command {
	char *type;
	matrix_ *matrix;
	deviceDB_ *devices;
	commandFunction_ unconfig;
	commandExeFunction_ execute;
	commandPrivate_ *private;
};

typedef struct _commandDB commandDB_;

int commandSolve(command_ *r, state_ *state, int itl);
int commandReSolve(command_ *r, state_ *state, int itl);

#endif
