/* 
 * Copyright (C) 2006 Cooper Street Innovations Inc.
 *	Charles Eidsness    <charles@cooper-street.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
 * 02110-1301, USA.
 *
 */

#ifndef NODE_H
#define NODE_H

typedef struct _node node_;

extern node_ gndNode;

int nodeDataPlus(node_ *r, double plus);
int nodeDataMinus(node_ *r, double minus);

int nodeDestroy(node_ **r);
node_ * nodeNew(node_ *r, int row, int col);

typedef struct _nodeDB nodeDB_;

nodeDB_ * nodeDBNext(nodeDB_ *r);
node_ * nodeDBGetNode(nodeDB_ *r);

int nodeDBLength(nodeDB_ *r);
int nodeDBInit(nodeDB_ *r, double *data, int *row, int *colStart);

node_ * nodeDBFind(nodeDB_ *r, int row, int col);
int nodeDBAttach(nodeDB_ *r, node_ *node);

int nodeDBDestroy(nodeDB_ **r);
int nodeDBDestroySafe(nodeDB_ **r);
nodeDB_ * nodeDBNew(nodeDB_ *r);

#endif
