/* 
 * Copyright (C) 2006 Cooper Street Innovations Inc.
 *	Charles Eidsness    <charles@cooper-street.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
 * 02110-1301, USA.
 *
 */

#ifndef ROW_H
#define ROW_H

typedef struct _row row_;

typedef enum {
	TYPE_NONE = -1,
	TYPE_NORMAL,
	TYPE_EXTENDED,
} rowType_;

extern row_ gndRow;

rowType_ rowGetType(row_ *r);
char * rowGetName(row_ *r);
int rowGetIndex(row_ *r);
double rowGetSolution(row_ *r);
double ** rowGetSolutionPtr(row_ *r);
int rowRHSPlus(row_ *r, double plus);
int rowRHSMinus(row_ *r, double minus);

int rowDestroy(row_ **r);
row_ * rowNew(row_ *r, char *name, rowType_ type, int index);

typedef struct _rowDB rowDB_;

rowDB_ * rowDBNext(rowDB_ *r);
row_ * rowDBGetRow(rowDB_ *r);

int rowDBWriteRaw(rowDB_ *r, FILE *outFile);

int rowDBLength(rowDB_ *r);
int rowDBInit(rowDB_ *r, double *rhs, double *solution);

row_ * rowDBFind(rowDB_ *r, char *name, rowType_ type);
int rowDBAttach(rowDB_ *r, row_ *row);

int rowDBDestroy(rowDB_ **r);
int rowDBDestroySafe(rowDB_ **r);
rowDB_ * rowDBNew(rowDB_ *r);

#endif

