/* 
 * Copyright (C) 2006 Cooper Street Innovations Inc.
 *	Charles Eidsness    <charles@cooper-street.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
 * 02110-1301, USA.
 *
 */

#ifndef STATE_H
#define STATE_H

typedef struct _state state_;

typedef enum {
	LU_ERR = -1,
	LU_SUPERLU = 0,
} stateLULibrary;

double stateGetAbsError(state_ *state, double i);
double stateGetVnError(state_ *state, double v);
double stateGetChgError(state_ *state, double ch);
double stateGetTrAbsError(state_ *state, double dd, double e);
double stateGetTrVnError(state_ *state, double dd, double e);
int stateGetITL1(state_ *r);
int stateGetITL4(state_ *r);
double stateGetMinbreak(state_ *r);
double stateGetGmin(state_ *r);
stateLULibrary stateGetLULibrary(state_ *r);
double stateGetTStop(state_ *r);
double stateGetTStep(state_ *r);
int stateMinbreakIsSet(state_ *r);

int stateDestroy(state_ **r);
state_ * stateNew(state_ *r);

#endif
